-- Old Instance Finder - DrKazza

--Declare Addon and libraries
local OldInstanceFinder = LibStub("AceAddon-3.0"):NewAddon("OldInstanceFinder", "AceConsole-3.0", "AceTimer-3.0")
local OIF = OldInstanceFinder
local wholib = LibStub:GetLibrary("LibWho-2.0"):Library()
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local L = LibStub("AceLocale-3.0"):GetLocale("OldInstanceFinder")


-- Specify Dungeons
local SearchList = { 
        BZ["Naxxramas"], 
        BZ["Ulduar"], 
        BZ["Temple of Ahn'Qiraj"], 
--[[       "Zul'Gurub",
      "Hyjal Summit",
      "Old Hillsbrad Foothills", 
      "The Black Morass", 
      "Karazhan", 
      "Zul'Aman", 
      "Magister's Terrace", 
      "Auchenai Crypts", 
      "Sethekk Halls", 
      "Shadow Labyrinth", 
      "Black Temple", 
      "Serpentshrine Cavern", 
      "The Steamvault", 
      "The Mechanar", 
      "The Botanica", 
      "The Arcatraz", 
      "The Eye", 
      "The Shattered Halls", 
      "The Blood Furnace", 
      "Hellfire Ramparts", 
      "Blackwing Lair", 
]]
      BZ["Molten Core"]
};

 -- Dungeons I don't care about 
	    -- Blackfathom Deeps, Dire Maul, Maraudon, Onyxia's Lair, Ragefire Chasm, Razorfen Downs, Razorfen Kraul 
	    -- Stratholme Past, Ruins of Ahn'Qiraj, Wailing Caverns, Zul'Farrak, Magtheridon's Lair
	    -- Blackrock Depths, Blackrock Spire, Deadmines, Gnomeregan, Sunwell Plateau, Scarlet Monastery (is this 4 locations?) 
	    -- Shadowfang Keep, Stormwind Stockade, Stratholme, Temple of Atal'Hakkar, Uldaman, Mana-Tombs, Scholomance 
	    -- The Slave Pens, The Underbog, Gruul's Lair, Ahn'kahet: The Old Kingdom, Azjol-Nerub, The Obsidian Sanctum 
	    -- Trial of the Champion, Trial of the Crusader, The Forge of Souls, Halls of Reflection, Pit of Saron, 
	    -- The Eye of Eternity, The Oculus, The Nexus, The Violet Hold, Halls of Lightning, Halls of Stone 
	    -- Utgarde Keep, Utgarde Pinnacle, Drak'Tharon Keep, Gundrak 


function OIF:OnInitialize()
    OIF:RegisterChatCommand("OIF", "Slash")
    OIF:RegisterChatCommand("OldInstanceFinder", "Slash")
end

function OIF:OnEnable()
    OIF:Print(L["Load"])
    wholib:RegisterCallback('WHOLIB_QUERY_RESULT', self.CatchWhoResults, self)
end

function OIF:Slash(msg)
    if msg then
        if tonumber(msg) then
            OIF:StartSearch(msg)
            -- would be nice to enhance to let people do a level range.
            return;
        end
    end
    OIF:Usage()
end

function OIF:Usage()
    OIF:Print(L["Usage"])
end

function OIF:StartSearch(lvl)
 

    OIF:Print((L["Startsearch"]):format(#SearchList))
    for i=1, #SearchList do
    searchquery = 'z-'..SearchList[i]..' '..lvl

--debug only
OIF:Print(searchquery)

    local searchresult = wholib:Who(
             searchquery,
         {
             queue = wholib.WHOLIB_QUEUE_SCANNING,
             --flags = whoLib.WHOLIB_FLAG_ALWAYS_CALLBACK,
             callback = self.CatchWhoResults
         });
         if(searchresult) then
             self.CatchWhoResults(searchresult);
         end
    end
end

function OIF:CatchWhoResults(results, complete)
    if results == nil or #results == 0 then
        -- no one in this dungeon
    else
        currentzone = results[1].Zone;
        level = results[1].Level;
        numofrunners = #results;
		if numofrunners == 1 then
			OIF:Print((L["OneHit"]) :format(level, currentzone))
		else
			OIF:Print((L["MoreHits"]) :format(numofrunners, level, currentzone))
		end
    end
end